package com.badbuta.learnspringbootrestfulsqlite;

import org.springframework.web.bind.annotation.RestController;

import com.google.gson.Gson;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.io.Reader;

import org.apache.ibatis.io.Resources;
import org.apache.ibatis.session.SqlSession;
import org.apache.ibatis.session.SqlSessionFactory;
import org.apache.ibatis.session.SqlSessionFactoryBuilder;
import org.springframework.web.bind.annotation.GetMapping;

/**
 * The RESTful API Controller Class
 * The URL for this API Controller is '/api'
 */
@RestController
@RequestMapping(value = "/api")
public class ApiController {

    // TODO Load the config from application.properties rather than var
    public static String MY_BATIS_CONFIG = "mybatis/config.xml";

    /**
     * API Endpoint = /api (or /api/)
     * 
     * @return Simple text
     */
    @RequestMapping(value = { "", "/" }, method = RequestMethod.GET)
    @ResponseBody
    public String getRoot() {
        // TODO: it is not a good practice and should return formatted JSON object
        return "This is API root";
    }

    // @GetMapping("/test")
    // public String getTest(@RequestParam(name = "a", required = false) String
    // valA) {
    // return "GET /test, param: a=" + valA;
    // }

    /**
     * Get the user(s) by id (using query-string param)
     * 
     * @param id The ID for
     * @return User object in JSON
     */
    @GetMapping("users")
    public String getUsers() {
        Gson gson = new Gson();

        try (Reader in = Resources.getResourceAsReader(MY_BATIS_CONFIG)) {
            // Create SQL Session Factory from mybatis config
            SqlSessionFactory factory = new SqlSessionFactoryBuilder().build(in);

            // Create session
            SqlSession session = factory.openSession();

            // Select users
            List<Map<String, Object>> result = session.selectList("mainapp.mybatis.selectUsers");

            return gson.toJson(result);

        } catch (IOException e) {
            // If exception, return the exception object in JSON
            // TODO: it is not a good practice and should return formatted error object
            return gson.toJson(e);
        }

    }

    @GetMapping("users/{id}")
    public String getUsersById(@RequestParam(name = "id", required = false) String id) {
        Gson gson = new Gson();

        try (Reader in = Resources.getResourceAsReader(MY_BATIS_CONFIG)) {
            // Create SQL Session Factory from mybatis config
            SqlSessionFactory factory = new SqlSessionFactoryBuilder().build(in);

            // Create session
            SqlSession session = factory.openSession();

            // Select users
            List<Map<String, Object>> result = session.selectList("mainapp.mybatis.selectUsers");

            return gson.toJson(result);

        } catch (IOException e) {
            // If exception, return the exception object in JSON
            // TODO: it is not a good practice and should return formatted error object
            return gson.toJson(e);
        }
    }

}
